import es, playerlib

###CONFIG###
f2b_message = es.ServerVar("f2b_message", "#green[Fade2Black] #defaultYou have been #lightgreenblinded#default for #lightgreenIP Ghosting#default.", "Message displayed to players who are ghosting.")
#############

es.ServerVar("fade2black_ver", "1.0").makepublic()
players = {}

def player_activate(event_var):
    setup(int(event_var["userid"]))

def load():
    for f2b_userid in playerlib.getPlayerList("#all"):
        setup(int(f2b_userid))

def unload():
    for f2b_userid in playerlib.getPlayerList("#all"):
        es.server.cmd("est_fade %d 1 0 0 0 0 0 255" % int(f2b_userid))

def setup(f2b_userid):
    global players
    if not int(f2b_userid) in players:
        f2b_player = playerlib.getPlayer(int(f2b_userid))
        players[int(f2b_userid)] = {}
        players[int(f2b_userid)]["ip"] = "test"
        players[int(f2b_userid)]["ghosted"] = 0
    else:
        if players[int(f2b_userid)]["ghosted"] == 1:
            f2b_address = players[int(f2b_userid)]["ip"]
            f2b_unghost = 1
            for f2b_checkid in playerlib.getPlayerList("#alive"):
                if players[int(f2b_checkid)]["ip"] == f2b_address:
                    f2b_unghost = 0
            if f2b_unghost == 1:
                es.server.cmd("est_fade %d 1 0 0 0 0 0 255" % int(f2b_userid))
                players[int(f2b_userid)]["ghosted"] = 0
            else:
                es.server.cmd("est_fade %s 2 1 1 0 0 0 255" % f2b_userid)

def player_death(event_var):
    global players
    f2b_ghosting = 0
    if int(event_var["userid"]) in players:
        f2b_address = players[int(event_var["userid"])]["ip"]
        for f2b_userid in playerlib.getPlayerList("#alive"):
            if int(f2b_userid) in players:
                if f2b_address == players[int(f2b_userid)]["ip"]:
                    f2b_ghosting = 1
    if f2b_ghosting == 1:
        players[int(event_var["userid"])]["ghosted"] = 1
        es.server.cmd("est_fade %s 2 1 1 0 0 0 255" % event_var["userid"])
        es.tell(event_var["userid"], "#multi", f2b_message)
    for f2b_userid in playerlib.getPlayerList("#all"):
        if int(f2b_userid) in players:
            if players[int(f2b_userid)]["ghosted"] == 1:
                f2b_address = players[int(f2b_userid)]["ip"]
                f2b_unghost = 1
                for f2b_checkid in playerlib.getPlayerList("#alive"):
                    if players[int(f2b_checkid)]["ip"] == f2b_address:
                        f2b_unghost = 0
                if f2b_unghost == 1:
                    es.server.cmd("est_fade %d 1 0 0 0 0 0 255" % int(f2b_userid))
                    players[int(f2b_userid)]["ghosted"] = 0

def player_spawn(event_var):
    global players
    if int(event_var["userid"]) in players:
        if players[int(event_var["userid"])]["ghosted"] == 1:
            es.server.cmd("est_fade %s 1 0 0 0 0 0 255" % event_var["userid"])
            players[int(event_var["userid"])]["ghosted"] = 0